<template>
    <div class="app-container">
        <el-row :gutter="20" type="flex" justify="center" align="middle">
            <el-col :lg="23" :md="23" :sm="24" align="middle" class="paper">
                <div class="filter-container">
                    <el-row :gutter="20">
                        <el-col :span="4" class="text-align-left">
                            <h3>Custom Fields</h3>
                        </el-col>
                        <el-col :span="20">
                            <el-row :gutter="20">
                                <el-col :lg="6" :md="6" :sm="24">
                                    <el-input 
                                        prop="keyword" 
                                        v-model="filter.keyword" 
                                        ref="keyword" 
                                        name="keyword" 
                                        placeholder="Name" 
                                        size="large" 
                                        class="filter-item width-100" 
                                        clearable 
                                        @keyup.enter.native="getCustomFields(1, false)" 
                                        @clear="getCustomFields(1, false)"/>
                                </el-col>
                                <el-col :lg="8" :md="8" :sm="24">
                                    <el-select
                                        ref="organization"
                                        name="organization"
                                        class="width-100"
                                        clearable
                                        filterable
                                        remote
                                        :remote-method="getFilterOrganizations"
                                        v-model="filter.organization"
                                        value-key="id"
                                        placeholder="Type organization name or code"
                                        no-data-text="No Record Found"
                                        :loading="organizationLoading"
                                        @clear="handleClearOrganization('filter')">
                                        <el-option
                                            v-for="item in filterOrganizations"
                                            :key="item.id"
                                            :label="item.name.capitalize()"
                                            :value="item.id">     
                                            <span style="float: left">{{ item.name.capitalize() }}</span>
                                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.code }}</strong>                   
                                        </el-option>
                                    </el-select>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button @click="getCustomFields(1, false)" size="small" type="primary" class="filter-item width-100" style="font-size:14px;">
                                        <i class="ion-ios-search"></i> Search
                                    </el-button>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button size="medium" type="success" class="filter-item width-100" style="font-size:14px;" @click="handleAddNew">
                                        <i class="ion-ios-add-circle"></i> Add
                                    </el-button>
                                </el-col>
                            </el-row>
                        </el-col>
                    </el-row>
                </div>
                <el-table v-loading="tableLoading" :data="customFields" style="width: 100%" :height="tableHeight()" fit highlight-current-row v-infinite-scroll="loadMore">
                    <el-table-column
                        fixed="left"
                        label="Name"
                        width="300">
                        <template slot-scope="scope">
                            <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Description"
                        width="200">
                        <template slot-scope="scope">
                            <span>{{ scope.row.description }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Organization"
                        width="200">
                        <template slot-scope="scope">
                            <span>{{ convertAmpersand(scope.row.organization.name).capitalize() }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Last Updated"
                        width="150">
                        <template slot-scope="scope">
                            {{ dateFormat(scope.row.updated) }}
                        </template>
                    </el-table-column>
                    <el-table-column
                        fixed="right"
                        label="Action"
                        min-width="200">
                        <template slot-scope="{row}">
                            <el-button v-permission="[row, 'customfield', 'viewown']" type="text" @click="handleEdit(row)">Edit</el-button>
                            <el-button v-permission="[row, 'customfield', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Delete</el-button>
                        </template>
                    </el-table-column>
                </el-table>

                <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
                    <el-form ref="customFieldForm" :model="customFieldForm" :rules="customFieldRules">
                        <aside>
                            <el-alert type="info" description="Add or edit document custom field" :closable=false show-icon></el-alert>
                        </aside>
                        <el-row :gutter="20">
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Name" prop="name">
                                    <el-input ref="name" name="name" v-model="customFieldForm.name" placeholder="Name" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Description" prop="description">
                                    <el-input ref="description" name="description" v-model="customFieldForm.description" placeholder="Description" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                        </el-row>
                        <el-row :gutter="20" v-if="user.role.slug == 'root'">
                            <el-col :lg="24" :md="24" :sm="24">
                                <el-form-item label="Organization" prop="organization">
                                    <el-select
                                        ref="organization"
                                        name="organization"
                                        class="width-100"
                                        clearable
                                        filterable
                                        remote
                                        :remote-method="getOrganizations"
                                        v-model="customFieldForm.organization"
                                        value-key="id"
                                        placeholder="Type organization name or code"
                                        no-data-text="No Record Found"
                                        :loading="organizationLoading"
                                        @clear="handleClearOrganization('content')">
                                        <el-option
                                            v-for="item in organizations"
                                            :key="item.id"
                                            :label="item.name.capitalize()"
                                            :value="item.id">     
                                            <span style="float: left">{{ item.name.capitalize() }}</span>
                                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.code }}</strong>                   
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>                            
                        </el-row> 
                        <div class="text-align-left">
                            <h3>Fields</h3>
                            <div v-for="(field, index) of customFieldForm.fields" :key="index" class="dynamic-list">
                                <el-row :gutter="20">
                                    <el-col :lg="12" :md="12" :sm="24">
                                        <el-form-item label="Name" prop="fieldname">
                                            <el-input ref="fieldname" name="fieldname" v-model="field.name" placeholder="Name" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                                        </el-form-item>
                                    </el-col>
                                    <el-col :lg="12" :md="12" :sm="24">
                                        <el-form-item label="Description" prop="fielddescription">
                                            <el-input ref="fielddescription" name="fielddescription" v-model="field.description" placeholder="Description" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                                        </el-form-item>
                                    </el-col>
                                </el-row>  
                                <el-row :gutter="20">
                                    <el-col :lg="12" :md="12" :sm="24">
                                        <el-form-item label="Field Type" prop="fieldtype">
                                            <el-select v-model="field.field" placeholder="Select field" class="width-100" ref="fieldtype" name="fieldtype">
                                                <el-option
                                                    v-for="item in fieldTypes"
                                                    :key="item.value"
                                                    :label="item.label"
                                                    :value="item.value">
                                                </el-option>
                                            </el-select>
                                        </el-form-item>
                                    </el-col>
                                    <el-col :lg="12" :md="12" :sm="24">
                                        <el-form-item label="Default Value" prop="fielddefaultvalue">
                                            <el-input ref="fielddefaultvalue" name="fielddefaultvalue" v-model="field.default" placeholder="Name" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                                        </el-form-item>
                                    </el-col>
                                </el-row>
                                <el-row :gutter="20" v-if="['radio', 'checkbox', 'select', 'switch'].indexOf(field.field) > -1">
                                    <el-col :lg="24" :md="24" :sm="24">
                                        <el-form-item label="Options" prop="fieldoptions">
                                            <el-input type="textarea" ref="fieldoptions" name="fieldoptions" v-model="field.options" placeholder="Format: key|label (enter)" autocomplete="off"></el-input>
                                        </el-form-item>
                                    </el-col>
                                </el-row>  
                                <el-row :gutter="20">
                                    <el-col :lg="24" :md="24" :sm="24">
                                        <el-switch
                                            v-model="field.required"
                                            active-text="Required"
                                            inactive-text="Optional">
                                        </el-switch>
                                    </el-col>
                                </el-row>
                                <el-form-item>
                                    <el-button class="float-right" @click="addField" v-if="(index + 1) == customFieldForm.fields.length" icon="el-icon-plus" type="success" size="mini"> Add</el-button>
                                    <el-button class="float-right" @click="deleteField(index)" v-else icon="el-icon-delete" type="danger" size="mini">Delete </el-button>
                                </el-form-item>
                            </div>
                        </div>                     
                    </el-form>
                    <span slot="footer" class="dialog-footer">
                        <el-button @click="showDialog = false" size="medium"><i class="ion-ios-close-circle-outline"></i> Cancel</el-button>
                        <el-button v-permission="[null, 'customfiels', 'editown']" @click="handleSubmit" size="medium" type="success">
                            <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                        </el-button>
                    </span>
                </el-dialog>
            </el-col>
        </el-row>
    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import { parseError, dateFormat, tableHeight, convertAmpersand } from '../../utils/index';
export default {
    name: 'CustomFields',
    directives: {
        permission
    },
    data(){

        var validateOrganization = (rule, value, callback) => {
            if(this.user.role.slug == 'root' && this.customFieldForm.organization == null){
                return callback(new Error('Organization is required'));
            }
            callback();
        };

        return{
            tableLoading: false,
            dialogLoading: false,
            organizationLoading: false,
            showDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Edit Custom Field',
                add: 'Add New Custom Field'
            },
            filter: {
                keyword: '',
                organization: null
            },
            fieldTypes: [{
                label: 'Text',
                value: 'text'
            }, {
                label: 'Email',
                value: 'email'
            }, {
                label: 'Number',
                value: 'number'
            }, {
                label: 'Textarea',
                value: 'textarea'
            }, {
                label: 'Select',
                value: 'select'
            }, {
                label: 'Checkbox',
                value: 'checkbox'
            }, {
                label: 'Radio',
                value: 'radio'
            }, {
                label: 'Datepicker',
                value: 'datepicker'
            }, {
                label: 'Timepicker',
                value: 'timepicker'
            }, {
                label: 'DateTimePicker',
                value: 'datetimepicker'
            }],
            customFieldForm: {
                id: null,
                name: '',
                description: '',
                organization: null,
                fields: [{
                    name: '',
                    description: '',
                    field: '',
                    default: '',
                    options: '',
                    required: true
                }]
            },
            customFieldRules: {
                name: [{ 
                    required: true, message: 'Custom field name is required', trigger: 'blur'
                }, {
                    max: 255, message: 'Custom field name length 255 characters', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9&()\s]{1,255})$/, 
                    message: 'Only letters, numbers, ampersand, brackets and spaces are allowed.', 
                    trigger: 'blur'
                }],
                description: [{ 
                    max: 255, 
                    message: 'Description length maximum 255 characters', 
                    trigger: 'blur'
                }],
                organization: [{ 
                    validator: validateOrganization, trigger: 'change'
                }]
            },
        }
    },
    computed:{
        ...mapGetters('auth', ['user']),
        ...mapGetters('organization', [
            'organizations',
            'filterOrganizations'
        ]),
        ...mapGetters('customfield', [
            'customFields',
            'pagination'
        ])
    },
    created(){
        const self = this;

        self.getCustomFields(1, false);

        if(self.user.role.slug != 'root'){
            self.customFieldForm.organization = self.user.organization.id; 
        }
    },
    methods: {
        dateFormat,
        tableHeight,
        convertAmpersand,
        getFilterOrganizations(q){
            const self = this;

            if(q.length >= 3){
                self.organizationLoading = true;
                self.$store.dispatch('organization/getOrganizations', {
                    q: q,
                    page: 1,
                    perpage: 25,
                    exclude: 'statuses',
                    type: 'filter'
                }).then(() => {
                    self.organizationLoading = false;
                });
            }
        },
        getOrganizations(q){
            const self = this;

            if(q.length >= 3){
                self.organizationLoading = true;
                self.$store.dispatch('organization/getOrganizations', {
                    q: q,
                    page: 1,
                    perpage: 25,
                    exclude: 'statuses',
                    type: 'content'
                }).then(() => {
                    self.organizationLoading = false;
                });
            }
        },
        getCustomFields(page, loadmore){
            const self = this;

            self.tableLoading = true;

            let params = {
                page: page,
                perpage: 25,
                loadmore: loadmore
            };

            if(self.filter.keyword.trim().length > 0){
                params.q = self.filter.keyword;
            }

            self.$store.dispatch('customfield/getCustomFields', params).then(()=>{
                self.tableLoading = false;
            });
        },
        loadMore(){
            const self = this;
            
            if(self.pagination.has_next){    
                self.getCustomFields(self.pagination.page + 1, true);
            }
        },
        handleAddNew(){
            const self = this;
            self.dialogStatus = 'add';
            self.showDialog = true;          
            self.$nextTick(() => {
                self.$refs['customFieldForm'].clearValidate();
            });
        },
        handleEdit(customfield){
            const self = this;
            self.dialogStatus = 'edit';
            self.showDialog = true;

            self.customFieldForm.id = customfield.id;
            self.customFieldForm.name = customfield.name;
            self.customFieldForm.description = customfield.description;
            self.customFieldForm.organization = customfield.organization.id;

            if(customfield.fields.length){
                self.customFieldForm.fields = [];
                for(const x of customfield.fields){
                    self.customFieldForm.fields.push({
                        name: x.name,
                        description: x.description,
                        field: x.field,
                        default: x.default,
                        options: x.options,
                        required: x.required
                    });
                }
            }

            self.getOrganizations(customfield.organization.name);

            self.$nextTick(() => {
                this.$refs['customFieldForm'].clearValidate();
            });
        },
        handleDelete(customfield){
            const self = this;

            self.$confirm('You are about to delete this custom field. This operation will affecting some modules become malfunction and this operation cannot be undone. Are you sure?', 'Warning', {
                confirmButtonText: 'Yes, I\'m Sure',
                cancelButtonText: 'Cancel'
            }).then(()=>{
                self.tableLoading = true;
                self.$store.dispatch('customfield/deleteCustomField', {
                    id: customfield.id
                }).then((response) => {
                    self.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        self.$message.error({
                            message: error.messages
                        });
                    }else{
                        self.$message.success({
                            message: response.message
                        });
                    }
                });
            });
        },
        handleSubmit(){
            const self = this;

            self.$refs.customFieldForm.validate((valid)=>{
                if(valid){

                    if(self.customFieldForm.fields.length == 0){
                        self.$message.error({
                            message: 'Fields is required'
                        });
                        return false;
                    }

                    self.dialogLoading = true;

                    let action = 'customfield/addCustomField';
                    let params = {
                        name: self.customFieldForm.name,
                        description: self.customFieldForm.description,
                        organization: self.customFieldForm.organization,
                        fields: self.customFieldForm.fields
                    };

                    if(self.dialogStatus == 'edit'){
                        action = 'customfield/editCustomField';
                        params.id = self.customFieldForm.id;
                    }

                    self.$store.dispatch(action, params).then((response)=>{
                        self.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            self.$message.error({
                                message: error.messages
                            });
                        }else{
                            self.showDialog = false;
                            self.$message.success({
                                message: response.message
                            });

                            self.resetForm();
                        }
                    });
                }else{
                    return false;
                }
            });
        },
        resetForm() {
            const self = this;

            self.customFieldForm = {
                id: null,
                name: '',
                description: '',
                ispublic: false,
                organization: null,
                fields: [{
                    name: '',
                    description: '',
                    field: '',
                    default: '',
                    options: '',
                    required: false
                }]
            };

            self.handleClearOrganization();
        },
        handleClearOrganization(type){
            const self = this;
            self.filter.organization = null;
            self.$store.dispatch('organization/resetOrganizations', {
                type: type
            });
        },
        addField() {
            const self = this;
            self.customFieldForm.fields.push({
                name: '',
                description: '',
                field: '',
                default: '',
                options: '',
                required: false
            });
        },
        deleteField(index) {
            const self = this;
            for(const [i, v] of self.customFieldForm.fields.entries()){
                if(i == index){
                    self.customFieldForm.fields.splice(i, 1);                    
                    break;
                }
            }
        }
    }
}
</script>